from setuptools import setup, find_packages

with open("README.md", "r") as stream:
    long_description = stream.read()

setup(
    name = "mafiaonline.py",
    version = "1.0.0",
    url = "https://github.com/Zakovskiy/mafiaonline.py",
    download_url = "https://github.com/Zakovskiy/mafiaonline.py/tarball/master",
    license = "MIT",
    author = "Zakovskiy",
    author_email = "gogrugu@gmail.com",
    description = "A library to create Mafia Online bots.",
    long_description = long_description,
    long_description_content_type = "text/markdown",
    keywords = [
        "mafia",
        "online",
        "mafiaonline",
        "mafiaonline.py",
        "mafiaonline-bot",
        "tokarev",
        "dottap",
        "api",
        "socket",
        "python",
        "python3",
        "python3.x",
        "zakovskiy",
        "official"
    ],
    install_requires = [
        "setuptools",
        "requests",
        "loguru",
        "aiohttp",
        "msgspec"
    ],
    setup_requires = [
        "wheel"
    ],
    packages = find_packages()
)
